// Generated by CoffeeScript 1.6.3
var contextify, global,
  _this = this;

global = this;

global.global = global.GLOBAL = global.root = global;

global.SANDBOX = true;

/*
Contextify is similar to deep clone, but changes context of all objects to vm's context.
*/


contextify = function(value, addtoglobal) {
  'use strict';
  var i, k, o, ut, v;
  ut = require('util');
  switch (typeof value) {
    case 'object':
      if (ut.isNull(value)) {
        o = null;
      }
      if (ut.isUndefined(value)) {
        o = void 0;
      } else if (ut.isDate(value)) {
        o = new Date(value.getTime());
      } else if (ut.isError(value)) {
        o = new Error(value.message);
      } else if (ut.isArray(value)) {
        o = (function() {
          var _i, _len, _results;
          _results = [];
          for (_i = 0, _len = value.length; _i < _len; _i++) {
            i = value[_i];
            _results.push(contextify(i));
          }
          return _results;
        })();
      } else if (ut.isRegExp(value)) {
        o = new RegExp(value.source, "" + (value.global ? "g" : "") + (value.ignoreCase ? "i" : "") + (value.multiline ? "i" : ""));
      } else if (ut.isBuffer(value)) {
        if (_this.Buffer) {
          o = new _this.Buffer(value.length);
          value.copy(object);
        } else {
          o = null;
        }
      } else {
        o = {};
        for (k in value) {
          v = value[k];
          o[k] = contextify(v);
        }
      }
      break;
    case 'function':
      o = function() {
        return value.apply(null, arguments);
      };
      break;
    default:
      o = value;
  }
  if (addtoglobal) {
    _this[addtoglobal] = o;
  }
  return o;
};

return contextify;
